//+------------------------------------------------------------------+
//|                                                  manualPairs.mq4 |
//|                                              Copyright 2017, xm7 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, xm7"
#property strict
#property indicator_chart_window

extern int IDnumber = 1; // The id of the indicator
extern int Xpos=10;
extern int Ypos=50;
extern string Pair1=""; 
extern string Pair1_Buy_or_Sell=""; 
extern string Pair2=""; 
extern string Pair2_Buy_or_Sell=""; 
extern string Pair3=""; 
extern string Pair3_Buy_or_Sell=""; 
extern string Pair4=""; 
extern string Pair4_Buy_or_Sell=""; 
extern string Pair5="";
extern string Pair5_Buy_or_Sell=""; 
extern string Pair6="";
extern string Pair6_Buy_or_Sell=""; 
extern string Pair7="";
extern string Pair7_Buy_or_Sell=""; 

string keyTitle,keyTrade;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   RemoveObjects("x7");  
        
   keyTitle="_Signals_TITLE_";
   keyTrade="_Signals_TRADE_";
   
   return(INIT_SUCCEEDED);
  }
     
void OnDeinit(const int reason){
   RemoveObjects("x7");
}       
     
//+------------------------------------------------------------------+
//| Custom indicator function                                        |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])

{
   string obj,objTitle;
   int y, dy=10;

//+----------------------------------------------------------------------------------+
//Display Signals Title                                                              |
//+----------------------------------------------------------------------------------+
   objTitle = (IDnumber<10?"0"+(string)IDnumber:(string)IDnumber)+"_x7"+keyTitle;
   if (ObjectFind(objTitle) == -1) ObjectCreate(ChartID(),objTitle,OBJ_LABEL,0,0,0,0);  
   ObjectSet(objTitle, OBJPROP_CORNER, 0);
   ObjectSet(objTitle, OBJPROP_XDISTANCE, Xpos);
   ObjectSet(objTitle, OBJPROP_YDISTANCE,Ypos);
   ObjectSetText(objTitle, "== "+(IDnumber<10?"0"+(string)IDnumber:(string)IDnumber)+" xm7 Signals ==", 13, "Verdana", White); 

//+----------------------------------------------------------------------------------+
//Display Pair1 - Pair7                                                              |
//+----------------------------------------------------------------------------------+   
   y=Ypos+10; 
   y+=dy;
   obj = Pair1;
   obj = (IDnumber<10?"0"+(string)IDnumber:(string)IDnumber)+"_x7"+keyTrade+Pair1;
   if (ObjectFind(obj) == -1) ObjectCreate(ChartID(),obj,OBJ_LABEL,0,0,0,0); 
   ObjectSet(obj, OBJPROP_CORNER, 0);
   ObjectSet(obj, OBJPROP_XDISTANCE, Xpos);   
   ObjectSet(obj, OBJPROP_YDISTANCE,y);
   ObjectSetText(obj,"   "+Pair1+" "+Pair1_Buy_or_Sell, 13, "Verdana", White);
   y+=dy;
   
   y=y+10; 
   obj = Pair2;
   obj = (IDnumber<10?"0"+(string)IDnumber:(string)IDnumber)+"_x7"+keyTrade+Pair2;
   if (ObjectFind(obj) == -1) ObjectCreate(ChartID(),obj,OBJ_LABEL,0,0,0,0); 
   ObjectSet(obj, OBJPROP_CORNER, 0);
   ObjectSet(obj, OBJPROP_XDISTANCE, Xpos);
   ObjectSet(obj, OBJPROP_YDISTANCE,y);
   ObjectSetText(obj,"   "+Pair2+" "+Pair2_Buy_or_Sell, 13, "Verdana", White);
   y+=dy;
   
   y=y+10; 
   obj = Pair3;  
   obj = (IDnumber<10?"0"+(string)IDnumber:(string)IDnumber)+"_x7"+keyTrade+Pair3;
   if (ObjectFind(obj) == -1) ObjectCreate(ChartID(),obj,OBJ_LABEL,0,0,0,0); 
   ObjectSet(obj, OBJPROP_CORNER, 0);
   ObjectSet(obj, OBJPROP_XDISTANCE, Xpos);      
   ObjectSet(obj, OBJPROP_YDISTANCE,y);
   ObjectSetText(obj,"   "+Pair3+" "+Pair3_Buy_or_Sell, 13, "Verdana", White);
   y+=dy;
   
   y=y+10; 
   obj = Pair4;
   obj = (IDnumber<10?"0"+(string)IDnumber:(string)IDnumber)+"_x7"+keyTrade+Pair4;
   if (ObjectFind(obj) == -1) ObjectCreate(ChartID(),obj,OBJ_LABEL,0,0,0,0); 
   ObjectSet(obj, OBJPROP_CORNER, 0);
   ObjectSet(obj, OBJPROP_XDISTANCE, Xpos);   
   ObjectSet(obj, OBJPROP_YDISTANCE,y);
   ObjectSetText(obj,"   "+Pair4+" "+Pair4_Buy_or_Sell, 13, "Verdana", White);
   y+=dy;
   
   y=y+10; 
   obj = Pair5; 
   obj = (IDnumber<10?"0"+(string)IDnumber:(string)IDnumber)+"_x7"+keyTrade+Pair5;
   if (ObjectFind(obj) == -1) ObjectCreate(ChartID(),obj,OBJ_LABEL,0,0,0,0); 
   ObjectSet(obj, OBJPROP_CORNER, 0);
   ObjectSet(obj, OBJPROP_XDISTANCE, Xpos);
   ObjectSet(obj, OBJPROP_YDISTANCE,y);
   ObjectSetText(obj,"   "+Pair5+" "+Pair5_Buy_or_Sell, 13, "Verdana", White);
   y+=dy;
   
   y=y+10; 
   obj = Pair6;
   obj = (IDnumber<10?"0"+(string)IDnumber:(string)IDnumber)+"_x7"+keyTrade+Pair6;
   if (ObjectFind(obj) == -1) ObjectCreate(ChartID(),obj,OBJ_LABEL,0,0,0,0); 
   ObjectSet(obj, OBJPROP_CORNER, 0);
   ObjectSet(obj, OBJPROP_XDISTANCE, Xpos);  
   ObjectSet(obj, OBJPROP_YDISTANCE,y);
   ObjectSetText(obj,"   "+Pair6+" "+Pair6_Buy_or_Sell, 13, "Verdana", White);
   y+=dy;
   
   y=y+10;
   obj = Pair7;  
   obj = (IDnumber<10?"0"+(string)IDnumber:(string)IDnumber)+"_x7"+keyTrade+Pair7;
   if (ObjectFind(obj) == -1) ObjectCreate(ChartID(),obj,OBJ_LABEL,0,0,0,0); 
   ObjectSet(obj, OBJPROP_CORNER, 0);
   ObjectSet(obj, OBJPROP_XDISTANCE, Xpos);   
   ObjectSet(obj, OBJPROP_YDISTANCE,y);
   ObjectSetText(obj,"   "+Pair7+" "+Pair7_Buy_or_Sell, 13, "Verdana", White);
   
   return(0);
 }  
 
 void RemoveObjects(string sz8) {  
   int t1=ObjectsTotal();
   while(t1>=0) {  
      if (StringFind(ObjectName(t1),sz8,0)>-1) ObjectDelete(ObjectName(t1)); 
      t1--;
    }
}